//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPresentationChild_h
#define PPresentationChild_h

#include "mozilla/dom/PPresentation.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/dom/ipc/IdType.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationRequestChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPresentationRequestParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationBuilderChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPresentationBuilderParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationBuilderChild;
} // namespace dom
} // namespace mozilla

namespace IPC {
class Principal;
} // namespace IPC

namespace mozilla {
namespace dom {


class PPresentationChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentChild;
    friend class mozilla::dom::PPresentationRequestChild;
    friend class mozilla::dom::PPresentationBuilderChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::dom::BuildTransportRequest BuildTransportRequest;
    typedef mozilla::dom::CloseSessionRequest CloseSessionRequest;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::HeaderEntry HeaderEntry;
    typedef mozilla::ipc::IPCBlobInputStreamParams IPCBlobInputStreamParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::dom::PresentationIPCRequest PresentationIPCRequest;
    typedef IPC::Principal Principal;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolFdMapping ProtocolFdMapping;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::ReconnectSessionRequest ReconnectSessionRequest;
    typedef mozilla::dom::SendSessionMessageRequest SendSessionMessageRequest;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SlicedInputStreamParams SlicedInputStreamParams;
    typedef mozilla::dom::StartSessionRequest StartSessionRequest;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::ipc::TemporaryFileInputStreamParams TemporaryFileInputStreamParams;
    typedef mozilla::dom::TerminateSessionRequest TerminateSessionRequest;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PPresentationRequestChild PPresentationRequestChild;
    typedef mozilla::dom::PPresentationRequestParent PPresentationRequestParent;
    typedef mozilla::dom::PPresentationBuilderChild PPresentationBuilderChild;
    typedef mozilla::dom::PPresentationBuilderParent PPresentationBuilderParent;

    typedef PPresentation::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvNotifyAvailableChange(
            nsTArray<nsString>&& aAvailabilityUrls,
            const bool& aAvailable) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifySessionStateChange(
            const nsString& aSessionId,
            const uint16_t& aState,
            const nsresult& aReason) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyMessage(
            const nsString& aSessionId,
            const nsCString& aData,
            const bool& aIsBinary) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifySessionConnect(
            const uint64_t& aWindowId,
            const nsString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyCloseSessionTransport(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPPresentationBuilderConstructor(
            PPresentationBuilderChild* actor,
            const nsString& aSessionId,
            const uint8_t& aRole);
    virtual PPresentationBuilderChild*
    AllocPPresentationBuilderChild(
            const nsString& aSessionId,
            const uint8_t& aRole) = 0;
    virtual bool
    DeallocPPresentationBuilderChild(PPresentationBuilderChild* aActor) = 0;
    virtual PPresentationRequestChild*
    AllocPPresentationRequestChild(const PresentationIPCRequest& aRequest) = 0;
    virtual bool
    DeallocPPresentationRequestChild(PPresentationRequestChild* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PPresentationChild();

    virtual ~PPresentationChild();

    PContentChild*
    Manager() const;

    void
    ManagedPPresentationBuilderChild(nsTArray<PPresentationBuilderChild*>& aArr) const;
    const ManagedContainer<PPresentationBuilderChild>&
    ManagedPPresentationBuilderChild() const;

    void
    ManagedPPresentationRequestChild(nsTArray<PPresentationRequestChild*>& aArr) const;
    const ManagedContainer<PPresentationRequestChild>&
    ManagedPPresentationRequestChild() const;

    static bool
    Send__delete__(PPresentationChild* actor);

    bool
    SendRegisterAvailabilityHandler(const nsTArray<nsString>& aAvailabilityUrls);

    bool
    SendUnregisterAvailabilityHandler(const nsTArray<nsString>& aAvailabilityUrls);

    bool
    SendRegisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole);

    bool
    SendUnregisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole);

    bool
    SendRegisterRespondingHandler(const uint64_t& aWindowId);

    bool
    SendUnregisterRespondingHandler(const uint64_t& aWindowId);

    PPresentationRequestChild*
    SendPPresentationRequestConstructor(const PresentationIPCRequest& aRequest);

    PPresentationRequestChild*
    SendPPresentationRequestConstructor(
            PPresentationRequestChild* actor,
            const PresentationIPCRequest& aRequest);

    bool
    SendNotifyReceiverReady(
            const nsString& aSessionId,
            const uint64_t& aWindowId,
            const bool& aIsLoading);

    bool
    SendNotifyTransportClosed(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PPresentationRequestChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationRequestChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const CloseSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CloseSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const SendSessionMessageRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SendSessionMessageRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPresentationBuilderChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationBuilderChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const StartSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            StartSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const TerminateSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            TerminateSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ReconnectSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ReconnectSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const BuildTransportRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            BuildTransportRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPresentationChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const PresentationIPCRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            PresentationIPCRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
    ManagedContainer<PPresentationBuilderChild> mManagedPPresentationBuilderChild;
    ManagedContainer<PPresentationRequestChild> mManagedPPresentationRequestChild;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class PresentationChild :
    public PPresentationChild
{
    virtual mozilla::ipc::IPCResult
    RecvNotifyAvailableChange(
            nsTArray<nsString>&& aAvailabilityUrls,
            const bool& aAvailable);

    virtual mozilla::ipc::IPCResult
    RecvNotifySessionStateChange(
            const nsString& aSessionId,
            const uint16_t& aState,
            const nsresult& aReason);

    virtual mozilla::ipc::IPCResult
    RecvNotifyMessage(
            const nsString& aSessionId,
            const nsCString& aData,
            const bool& aIsBinary);

    virtual mozilla::ipc::IPCResult
    RecvNotifySessionConnect(
            const uint64_t& aWindowId,
            const nsString& aSessionId);

    virtual mozilla::ipc::IPCResult
    RecvNotifyCloseSessionTransport(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason);

    virtual PPresentationBuilderChild*
    AllocPPresentationBuilderChild(
            const nsString& aSessionId,
            const uint8_t& aRole);

    virtual bool
    DeallocPPresentationBuilderChild(PPresentationBuilderChild* aActor);

    virtual PPresentationRequestChild*
    AllocPPresentationRequestChild(const PresentationIPCRequest& aRequest);

    virtual bool
    DeallocPPresentationRequestChild(PPresentationRequestChild* aActor);

    MOZ_IMPLICIT PresentationChild();
    virtual ~PresentationChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
PresentationChild::RecvNotifyAvailableChange(
        nsTArray<nsString>&& aAvailabilityUrls,
        const bool& aAvailable)
{
}

mozilla::ipc::IPCResult
PresentationChild::RecvNotifySessionStateChange(
        const nsString& aSessionId,
        const uint16_t& aState,
        const nsresult& aReason)
{
}

mozilla::ipc::IPCResult
PresentationChild::RecvNotifyMessage(
        const nsString& aSessionId,
        const nsCString& aData,
        const bool& aIsBinary)
{
}

mozilla::ipc::IPCResult
PresentationChild::RecvNotifySessionConnect(
        const uint64_t& aWindowId,
        const nsString& aSessionId)
{
}

mozilla::ipc::IPCResult
PresentationChild::RecvNotifyCloseSessionTransport(
        const nsString& aSessionId,
        const uint8_t& aRole,
        const nsresult& aReason)
{
}

PPresentationBuilderChild*
PresentationChild::AllocPPresentationBuilderChild(
        const nsString& aSessionId,
        const uint8_t& aRole)
{
    return 0;
}

bool
PresentationChild::DeallocPPresentationBuilderChild(PPresentationBuilderChild* aActor)
{
    return false;
}

PPresentationRequestChild*
PresentationChild::AllocPPresentationRequestChild(const PresentationIPCRequest& aRequest)
{
    return 0;
}

bool
PresentationChild::DeallocPPresentationRequestChild(PPresentationRequestChild* aActor)
{
    return false;
}

MOZ_IMPLICIT PresentationChild::PresentationChild()
{
    MOZ_COUNT_CTOR(PresentationChild);
}

MOZ_IMPLICIT PresentationChild::~PresentationChild()
{
    MOZ_COUNT_DTOR(PresentationChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PPresentationChild_h
